\documentclass{article}
\usepackage[utf8]{inputenc}

\title{Tutorials Nix}
\author{Manon CHABRE / Daniel COSCIA / Bastien DE ARAUJO}
\date{March 2019}

\usepackage{natbib}
\usepackage{graphicx}
\usepackage{hyperref}
\usepackage{varwidth}

\begin{document}

\maketitle

\section{NIX utilisation tutorial}

First you have to install Nix, you can download Nix at the link just below:
\href{https://nixos.org/nix/download.html}{https://nixos.org/nix/download.html} % site internet 
\newline
\newline
After installing Nix you just have to follow the steps below to use what you need for courses.
\newline
To recover all tools that you need in one courses, you just have to type this command :
\fbox{nix-shell '$<nixpkgs>$' -A nur.repos.INFO4-19.\$$<course>$\$}
\newline
\newline
When you change the course you change your environment, so you don't have the access of the tools of the previous course anymore.
\newline
\newline
If you need to cleanup all the environments intall on your computer, you just have to type this command :
\fbox{nix-collect-garbage}
\newline
Like that, what's left in the nix store is everything being referenced from the roots. You can also cleanup everything and upgrade your nix like that :
\newline
\fbox{\begin{varwidth}{\textwidth}
nix-channel --upgrade\\ 
nix-env -u --always\\
rm /nix/var/nix/gcroots/auto/*\\
nix-collect-garbage -d
\end{varwidth}}

\section{Nix development tutorial}

\subsection{Create a Package}

\subsubsection{From an archive}
\textit{Default.nix :}
\{ stdenv, fetchurl \}: (1) \newline 
stdenv.mkDerivation rec \{ (2) \newline 
|  version = "4.07.1"; (3) \newline 
|  name = "Ocaml-\$\{version\}"; (4) \newline 
|  builder = ./builder.sh; (5) \newline 
|  src = fetchurl { (6) \newline 
|  |  url = "http://caml.inria.fr/pub/distrib/Ocaml-4.07/Ocaml-\$\{version\}.tar.gz"; \newline 
|  |  sha256 = "1x4sln131mcspisr22qc304590rvg720rbl7g2i4xiymgvhkpm1a"; \newline 
|  \}; \newline 
\} \newline 
(1) This line states that this Nix expression is a function.
A function in Nix is represented by : \{ a, b, ... \} : f
\newline
Where \{ a, b, ... \} are the arguments and f is the function.
\newline
(2) This line allows to create a package. In order to create a package we need to make a derivation by calling stdenv.mkDerivation. The word "rec" allows to use some variable on the same package. We are going to see that later.
\newline
(3) This is just an example of declaration of a variable.
\newline Here this variable is the version of Ocaml that we want to download.
\newline
(4) Here is the name of the derivation. Be careful though it's a must have in order to create a derivation. Here the name will be "Ocaml-4.07.1" thanks to the variable "version" set previously.
\newline
(5) Here we are setting the script that will build the program.
We will see that in the second part.
Sometimes the builder can not be set, in this case mkDerivation will fill in a default builder (which does a configure; make; make install).
(6) Here we are defining the source of the package. The function fetchurl is able to download a file from an url and check the file downloaded with a hashcode.
\newline\newline
\textit{Builder.sh :}
source \$stdenv/setup (1)\newline 
tar xvfz \$src (2)\newline 
cd Ocaml-* (3)\newline 
./configure --prefix \$out\newline 
make world\newline 
umask 022\newline 
make install\newline 

(1) Setup the environment because when Nix build a package it clears the environment in order to avoid problems of dependency. 
\newline
(2) This line allows to uncompress the file downloaded. The value \$src is the path to the file downloaded.
\newline
(3) Change the directory in order to compile the program.
\newline
Note : From this point every package is different.
Most of the time the compilation lines are given by the developer of the program in the sources (for example in the README or the INSTALL file)
\newpage
\subsubsection{From an archive w/ pre-complied code}

\{ stdenv, fetchurl \}:\newline 
stdenv.mkDerivation \{\newline 
|    name = "lustreV4";\newline 
|    src = fetchurl \{\newline 
|    |    url = http://www-verimag.imag.fr/DIST-TOOLS/SYNCHRONE/lustre-v4/distrib/linux64/lustre-v4-III-dc-linux64.tgz;\newline 
|    |    sha256 = "0ynk5mm68ywz6w3qncs2klyz6l9k97yk2b4bpkwk3k3zxhvxbgqr";\newline 
|    \};\newline 
|    installPhase = '' (1)\newline 
|    mkdir -p \$out/bin (2)\newline 
|    cd bin (3)\newline 
|    cp * \$out/bin/ (4)\newline 
|    chmod +x \$out/bin/* (5)\newline 
|    '';\newline 
\};\newline 

Note : The principle is the same, we just don't have to compile the source.
\newline
(1) We just need to change the installPhase of the default builder of the package.
\newline
(2) We have to create a directory where there will be our compiled program.
\newline
(3) Here the programs are compiled in the bin directory of the archive.
\newline
(4) We copy all the compiled programs into the folder on our derivation.
\newline
(5) We modify the permission to execute the programs.
\newline
\subsubsection{From a package of NixPkgs}

Note : NixPkgs is a packages collection for the Nix package manager. The name of all the packages are located on the nixpkgs/pkgs/top-level/all-packages.nix file.
\newline
\newline
So, you just have to search in NixPkgs the name of the package that you want and create an environment with them, see the part below. 
\newline
\newpage
\subsection{Create an Environment}
An environment is a new package in which you can put one or several packages already created (like explains in the last part). This package can be executed with the command : nix-shell which permit to switch of environment.
\newline
\newline
For example for ALM1 : \newline 
stdenv.mkDerivation \{\newline 
|  name = "ALM1";\newline 
|  shellHook = ''\newline 
|  |    echo -e "\\e[32m=============================================\\e[0m"\newline 
|  |    echo -e "\\e[32m=== Welcome to ALM1 environment ===\\e[0m"\newline 
|  |    echo -e "\\e[32m=============================================\\e[0m"\newline 
|  '';\newline 
|  buildInputs = [ lustre ]; (1)\newline 
\}\newline 

(1) buildInputs allows to link with another package as an input (here it's package lustre explain before), which you have create before or provide to NixPkgs. You can add as many package that you want. Furthermore, if the package that you call is in binary it is added to the PATH but if it's a subdirectory, it is added to GCC's header search path.

\section{Nix development tests}
In order to test our packages without to much difficulties, we need to organize them in a repository.
This repository is composed with a default.nix at the top of the folder with a "pkgs" folder which contains all the packages with their own default.nix.
\newline
In this default.nix of the repository we have :\newline 
\{ pkgs ? import $<nixpkgs>$ \{\} \}: (1)\newline 
\{ (2)\newline 
|  example-package = pkgs.callPackage ./pkgs/example-package \{ \};\newline 
|  helloworld = pkgs.callPackage ./pkgs/helloworld \{ \};\newline 
|  PF-LT = pkgs.callPackage ./pkgs/PF-LT \{\};\newline 
|  ALM1 = pkgs.callPackage ./pkgs/ALM1 \{\};\newline 
\}\newline 

(1) This line import all the packages from NixPkgs in the pkgs variable.
\newline
(2) To call a package we are using a function from NixPkgs called "callPackage" followed by the path of your package.
\newline
\newline
Finally to test a environment we run this command in the folder of the repository : \fbox{nix-shell -A \$$< Name Of The Package >$\$}

\section{NUR tutorial}
The NUR was created to share new packages Nix to a large community. 
You can find all information of NUR on :
\url{https://github.com/nix-community/NUR}
To push your own repository on NUR : 
\begin{itemize}
\item Fork the NUR github.
\item Add your repository git on \textbf{\textit{repos.json}}. \newline
Example :\newline 
\{\newline 
|    "repos": \{\newline 
|     |   "$<fill-your-repo-name>$": \{\newline 
|     |    |   "url": "https://github.com/$<your-user>$/$<your-repo>$"\newline 
|     |   \},\newline 
|     |   ... Other repo name\newline 
|    \}\newline 
\}\newline 

\item Push and send pull request on \url{https://github.com/nix-community/NUR}.


If the pull request is accepted, your repo will be synchonised with the NUR and you will be able to recover your packages with the command explained in the \textbf{\textit{Nix utilisation tutorial}} parts.

\item Once you have updated your repo it is possible that the package that you want to download isn't available. This is because NUR only check once a day for repo updates. In order to update NUR faster you can use this command line : \fbox{curl -XPOST https://nur-update.herokuapp.com/update?repo=\textit{\$$< repo -name >$\$}}
\end{itemize}

\end{document}
